scala.tools.reflect

# ToolBox

###
Related Doc: package reflect

#### trait ToolBox[U <: Universe] extends AnyRef

Source
  ToolBox.scala

Linear Supertypes
AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. ToolBox
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Visibility

1. Public
2. All

### Type Members

1. #### abstract type TypecheckMode

   Represents mode of operations of the typechecker underlying `c.typecheck` calls.

   Represents mode of operations of the typechecker underlying `c.typecheck` calls. Is necessary since the shape of the typechecked tree alone is not enough to guess how it should be typechecked. Can be EXPRmode (typecheck as a term), TYPEmode (typecheck as a type) or PATTERNmode (typecheck as a pattern).

### Abstract Value Members

1. #### abstract val PATTERNmode: TypecheckMode

   Indicates that an argument to `c.typecheck` should be typechecked as a pattern.

2. #### abstract val TERMmode: TypecheckMode

   Indicates that an argument to `c.typecheck` should be typechecked as a term.

   Indicates that an argument to `c.typecheck` should be typechecked as a term. This is the default typechecking mode in Scala 2.11 and the only one supported in Scala 2.10.

3. #### abstract val TYPEmode: TypecheckMode

   Indicates that an argument to `c.typecheck` should be typechecked as a type.

4. #### abstract def compile(tree: U.Tree): () ⇒ Any

   Compiles a tree using this ToolBox.

   Compiles a tree using this ToolBox.

   If the tree has unresolved type variables (represented as instances of `FreeTypeSymbol` symbols), then they all have to be resolved first using `Tree.substituteTypes`, or an error occurs.

   This spawns the compiler at the Namer phase, and pipelines the tree through that compiler. Currently `compile` does not accept trees that already typechecked, because typechecking isn't idempotent. For more info, take a look at https://issues.scala-lang.org/browse/SI-5464.

5. #### abstract def define(tree: U.ImplDef): U.Symbol

   Defines a top-level class, trait or module in this ToolBox, putting it into a uniquely-named package and returning a symbol that references the defined entity.

   Defines a top-level class, trait or module in this ToolBox, putting it into a uniquely-named package and returning a symbol that references the defined entity. For a ClassDef, a ClassSymbol is returned, and for a ModuleDef, a ModuleSymbol is returned (not a module class, but a module itself).

   This method can be used to generate definitions that will later be re-used by subsequent calls to `compile`, `define` or `eval`. To refer to the generated definition in a tree, use q"$sym".

6. #### abstract def eval(tree: U.Tree): Any

   Compiles and runs a tree using this ToolBox.

   Compiles and runs a tree using this ToolBox. Is equivalent to `compile(tree)()`.

7. #### abstract def frontEnd: FrontEnd

   Front end of the toolbox.

   Front end of the toolbox.

   Accumulates and displays warnings and errors, can drop to interactive mode (if supported). The latter can be useful to study the typechecker or to debug complex macros.

   scala.tools.reflect provides two predefined front ends that can be created using scala.tools.reflect.mkSilentFrontEnd and scala.tools.reflect.mkConsoleFrontEnd.

8. #### abstract def inferImplicitValue(pt: U.Type, silent: Boolean = true, withMacrosDisabled: Boolean = false, pos: U.Position = u.NoPosition): U.Tree

   Infers an implicit value of the expected type `pt` in top-level context.

   Infers an implicit value of the expected type `pt` in top-level context. Optional `pos` parameter provides a position that will be associated with the implicit search.

   As mentioned in https://groups.google.com/forum/#!topic/scala-internals/ta-vbUT6JE8 this API won't take into account the lexical context of the callsite, because currently it's impossible to reify it.

   If `silent` is false, `ToolBoxError` will be thrown in case of an inference error. If `silent` is true, the typecheck is silent and will return `EmptyTree` if an error occurs. Such errors don't vanish and can be inspected by turning on -Xlog-implicits. Unlike in `typecheck`, `silent` is true by default.

9. #### abstract def inferImplicitView(tree: U.Tree, from: U.Type, to: U.Type, silent: Boolean = true, withMacrosDisabled: Boolean = false, pos: U.Position = u.NoPosition): U.Tree

   Infers an implicit view from the provided tree `tree` from the type `from` to the type `to` in the toplevel context.

   Infers an implicit view from the provided tree `tree` from the type `from` to the type `to` in the toplevel context. Optional `pos` parameter provides a position that will be associated with the implicit search.

   As mentioned in https://groups.google.com/forum/#!topic/scala-internals/ta-vbUT6JE8 this API won't take into account the lexical context of the callsite, because currently it's impossible to reify it.

   If `silent` is false, `ToolBoxError` will be thrown in case of an inference error. If `silent` is true, the typecheck is silent and will return `EmptyTree` if an error occurs. Such errors don't vanish and can be inspected by turning on -Xlog-implicits. Unlike in `typecheck`, `silent` is true by default.

10. #### abstract val mirror: U.Mirror

    Underlying mirror of a ToolBox

11. #### abstract def parse(code: String): U.Tree

    ..

12. #### abstract def typecheck(tree: U.Tree, mode: TypecheckMode = TERMmode, pt: U.Type = u.WildcardType, silent: Boolean = false, withImplicitViewsDisabled: Boolean = false, withMacrosDisabled: Boolean = false): U.Tree

    Typechecks a tree against the expected type `pt` under typechecking mode specified in `mode` with EXPRmode being default.

    Typechecks a tree against the expected type `pt` under typechecking mode specified in `mode` with EXPRmode being default. This populates symbols and types of the tree and possibly transforms it to reflect certain desugarings.

    If the tree has unresolved type variables (represented as instances of `FreeTypeSymbol` symbols), then they all have to be resolved first using `Tree.substituteTypes`, or an error occurs.

    If `silent` is false, `ToolBoxError` will be thrown in case of a typecheck error. If `silent` is true, the typecheck is silent and will return `EmptyTree` if an error occurs. Such errors don't vanish and can be inspected by turning on -Ydebug.

    Typechecking can be steered with the following optional parameters: `withImplicitViewsDisabled` recursively prohibits implicit views (though, implicit vals will still be looked up and filled in), default value is false `withMacrosDisabled` recursively prohibits macro expansions and macro-based implicits, default value is false

13. #### abstract val u: U

    Underlying universe of a ToolBox

14. #### abstract def untypecheck(tree: U.Tree): U.Tree

    See also

      scala.reflect.macros.Typers.untypecheck

15. #### abstract def resetLocalAttrs(tree: U.Tree): U.Tree

    Recursively resets locally defined symbols and types in a given tree.

    Recursively resets locally defined symbols and types in a given tree. WARNING: Don't use this API, go for untypecheck instead.

    Annotations
      @deprecated
    Deprecated

      (Since version 2.11.0) Use `tb.untypecheck` instead

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from ToolBox[U] to any2stringadd[ToolBox[U]] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (ToolBox[U], B)

   Implicit information
     This member is added by an implicit conversion from ToolBox[U] to ArrowAssoc[ToolBox[U]] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

7. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
   Note

     not specified by SLS as a member of AnyRef

8. #### def ensuring(cond: (ToolBox[U]) ⇒ Boolean, msg: ⇒ Any): ToolBox[U]

   Implicit information
     This member is added by an implicit conversion from ToolBox[U] to Ensuring[ToolBox[U]] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring

9. #### def ensuring(cond: (ToolBox[U]) ⇒ Boolean): ToolBox[U]

   Implicit information
     This member is added by an implicit conversion from ToolBox[U] to Ensuring[ToolBox[U]] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring

10. #### def ensuring(cond: Boolean, msg: ⇒ Any): ToolBox[U]

    Implicit information
      This member is added by an implicit conversion from ToolBox[U] to Ensuring[ToolBox[U]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

11. #### def ensuring(cond: Boolean): ToolBox[U]

    Implicit information
      This member is added by an implicit conversion from ToolBox[U] to Ensuring[ToolBox[U]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

13. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

14. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

15. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from ToolBox[U] to StringFormat[ToolBox[U]] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

16. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

17. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

18. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

19. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

20. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

21. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

22. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

23. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

24. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

25. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

26. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

27. #### def →[B](y: B): (ToolBox[U], B)

    Implicit information
      This member is added by an implicit conversion from ToolBox[U] to ArrowAssoc[ToolBox[U]] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Deprecated Value Members

1. #### def typeCheck(tree: U.Tree, pt: U.Type = u.WildcardType, silent: Boolean = false, withImplicitViewsDisabled: Boolean = false, withMacrosDisabled: Boolean = false): U.Tree

   Annotations
     @deprecated
   Deprecated

     (Since version 2.11.0) Use `tb.typecheck` instead

   See also

     `Typers.typecheck`

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from ToolBox[U] to any2stringadd[ToolBox[U]]

### Inherited by implicit conversion StringFormat from ToolBox[U] to StringFormat[ToolBox[U]]

### Inherited by implicit conversion Ensuring from ToolBox[U] to Ensuring[ToolBox[U]]

### Inherited by implicit conversion ArrowAssoc from ToolBox[U] to ArrowAssoc[ToolBox[U]]

### Ungrouped